<!-- setOptions 设置规格组件 -->
<template>
  <div>
    <div v-if="specShow" class="">
      <setSpec ref="setSpec" :spec="Options.spec" @refresh="refresh" />
      <el-table size="mini" :data="Options.options" border style="width: 100%">
        <el-table-column v-for="(item , index ) in Options.spec" :key="index" :label="item.title">
          <template slot-scope="scope">{{findOptionsKeyName(scope.row,item.title)}}</template>
        </el-table-column>

        <el-table-column align="center" width="60">
          <template slot="header" slot-scope="scope">图片</template>
          <template slot-scope="scope">
            <div @click="clickImg(scope.row)">
              <el-upload class="goods-img" :action="m_action" :show-file-list="false" name="images" :with-credentials="true" :on-success="handleAvatarSuccess">
                <img v-if="scope.row.images" :src="scope.row.images" alt="">
                <i v-else class="el-icon-plus"></i>

              </el-upload>
            </div>
          </template>
        </el-table-column>

        <el-table-column align="center">
          <template slot="header" slot-scope="scope">库存</template>
          <template slot-scope="scope">
            <el-input-number class="w100p" :controls="false" :precision="null" type="text" size="mini" v-model="scope.row.stock" />
          </template>
        </el-table-column>

        <el-table-column align="center">
          <template slot="header" slot-scope="scope">售价</template>
          <template slot-scope="scope">
            <el-input-number class="w100p" :controls="false" :precision="null" type="text" size="mini" v-model="scope.row.price" />
          </template>
        </el-table-column>

        <el-table-column align="center">
          <template slot="header" slot-scope="scope">原价</template>
          <template slot-scope="scope">
            <el-input-number class="w100p" :controls="false" :precision="null" type="text" size="mini" v-model="scope.row.original_price" />
          </template>
        </el-table-column>

        <el-table-column align="center">
          <template slot="header" slot-scope="scope">成本</template>
          <template slot-scope="scope">
            <el-input-number class="w100p" :controls="false" :precision="null" type="text" size="mini" v-model="scope.row.cost_price" />
          </template>
        </el-table-column>

      </el-table>
    </div>
  </div>
</template>

<script>
import setSpec from './setSpec'
export default {
  name: 'setOptions',
  components: { setSpec },
  props: {
    options: {
      type: Object,
    }
  },
  data() {
    return {
      specShow: false,
      Options: this.options,
      optionsItem: {
        title: '', //组合标题
        images: '', //图片
        price: '', //售价
        original_price: '', //原价
        cost_price: '', //成本
        stock: '', //库存
        sort: '0',//排序
        specs: [],//规格组合,
      },
      checkRow: {}

    }
  },
  mounted() {
    this.init()
  },
  methods: {
    //初始化方法
    init() {
      this.initData()
    },
    initData() {
      this.specShow = false
      this.Options.options = this.Options.options || [] //规格集合
      this.Options.spec = this.Options.spec || [] //规格一级分类,如大小,颜色,尺寸
      this.$nextTick(() => {
        this.specShow = true
      })
    },

    findOptionsKeyName(item, key) {
      let i = item.specs.find(e => {
        return e.key == key

      }) || {}
      return i.name

    },

    createdRule() {
      let options = this._dep(this.Options.options)
      let rules = this.createdSpecs().map(i => {
        let item = this._dep(this.optionsItem)
        let findItem = this.findOptionsItem(options, i)
        console.log(findItem, 'findItem')
        if (findItem) {
          item = this._dep(findItem)
        } else {
          item.specs = this._dep(i)
          item.title = i.map(e => e.name).join('_')
        }

        return item
      })
      this.Options.options = rules
      this.resetView()
      // console.log(rules)
    },

    //找到对应数组
    findOptionsItem(targetArr, arr) {
      let item = targetArr.find(i => {
        let targetObj = this.arrayToObj(i.specs)
        let arrObj = this.arrayToObj(arr)
        console.log(targetObj, arrObj)
        return this.isEqObj(targetObj, arrObj)
      })
      return item
    },

    //数组变对象
    arrayToObj(arr) {
      let obj = {}
      arr.forEach(i => {
        obj[i.key] = i.name
      })
      return this._dep(obj)

    },

    //判断对象是否相等
    isEqObj(obj1, obj2) {
      let o1 = this._dep(obj1)
      let o2 = this._dep(obj2)
      let o1Keys = Object.keys(o1)
      let o2Keys = Object.keys(o2)
      if (o1Keys.length != o2Keys.length) { return false }
      for (let len = o1Keys.length; len--;) {
        let key = o1Keys[len]
        if (o1[key] != o2[key]) {
          return false
        }
      }
      return true

    },

    //生成 规格组合,例如 大_红色_18
    createdSpecs() {
      console.log(this.Options.spec)
      let arr = this._dep(this.Options.spec.map(i => {
        let titles = i.spec_item.map(item => {
          let o = {
            key: i.title,
            name: item.title
          }
          return o
        })
        return titles
      }))
      let results = []
      let result = []
      let that = this
      if (!arr.length) {
        return []
      }
      doExchange(arr, 0);
      function doExchange(arr, index) {
        for (var i = 0; i < arr[index].length; i++) {
          result[index] = arr[index][i];
          if (index != arr.length - 1) {
            doExchange(arr, index + 1)
          } else {
            results.push(that._dep(result))
          }
        }
      }
      //  console.log(results)
      return this._dep(results)

    },

    refresh() {
      if (!this.isNoSpec()) {
        this.m_warning('规格名称不能为空')
        return
      }

       if(!this.isEqSpce()){return}
      this.createdRule()
    },

    //判断规格项为空
    isNoSpec() {
      let spec = this._dep(this.options.spec)
      let item = spec.find(i => !i.title)
      if (item) {
        return false
      }
      let specItems = []
      spec.forEach(i => {
        specItems = [...specItems, ...i.spec_item]
      })
      let specItem = specItems.find(i => !i.title)
      if (specItem) {
        return false
      }

      return true

    },

    isEqSpce() {
      let spec = this._dep(this.options.spec)
      let SpecTitle = spec.map(i => i.title)
      let eqSpecArr = this.findEqArray(SpecTitle)
      if(eqSpecArr.length){
         let eqSpecArrString  = eqSpecArr.join('】,【')
        this.m_warning(`存在相同的规格名称 【${eqSpecArrString}】`)
        return false
      }

      for(let len =spec.length;len--; ){
        let item = spec[len]
        if(!item.spec_item.length){
          this.m_warning(`规格【${item.title}】没有规格项`)
          return false
        }
        let speEqs =  this.findEqArray(item.spec_item.map(i=>i.title))
        if(speEqs.length){
           let speEqsString  = speEqs.join('】,【')
           this.m_warning(`规格【${item.title}】存在相同规格项 【${speEqsString}】`)
          return false
        }
      }

     

      return true
    },

    findEqArray(arr) {
      var temp = [];
      arr.sort().sort(function (a, b) {
        if (a === b && temp.indexOf(a) === -1) {
          temp.push(a)
        }
      })
      return this._dep(temp)

    },

    //刷新视图
    resetView() {
      this.specShow = false
      this.$nextTick(() => {
        this.specShow = true
      })
    },

    clickImg(row) {
      //  console.log(row)
      this.checkRow = row
    },
    handleAvatarSuccess(res) {
      this.checkRow.images = res.data

    },
  },
}

</script>
<style lang='scss' scoped>
.goods-img {
  width: 40px;
  height: 40px;
  text-align: center;
  line-height: 40px;
  border: 1px solid #eee;
  img {
    width: 100%;
    height: 100%;
    display: block;
  }
}

.w100p {
  width: 100% !important;
}
</style>